import { CachePublicRecord, TolgeeInstance, TolgeeStaticData } from '@tolgee/web';
/**
 * Updates tolgee static data and language, to be ready right away for the first render
 * and therefore compatible with SSR.
 *
 * It also ensures that the first render is done without wrapping and so it avoids
 * "client different than server" issues.
 * *
 * @param tolgeeInstance initialized Tolgee instance
 * @param language language that is obtained outside of Tolgee on the server and client
 * @param staticData static data for the language
 * @param enabled if set to false, no action is taken
 */
export declare function useTolgeeSSR(tolgeeInstance: TolgeeInstance, language?: string, data?: TolgeeStaticData | CachePublicRecord[] | undefined, enabled?: boolean): TolgeeInstance;
